#ifndef _ASMCLASSES_
#define _ASMCLASSES_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"

#include "lists.h"
#include "errors.h"


//-----------------------------------------------------------------------------
//---= enum/typedef =----------------------------------------------------------
//-----------------------------------------------------------------------------
enum
{
    CLS_TYPE_SEG,
    CLS_TYPE_PROC,
    CLS_TYPE_TBL,
    CLS_TYPE_VPU,

    CLS_TYPE_CLOSED = 128
};

typedef struct
{
    __int8  type;				//CLS_TYPE_xxx

    DWORD   last;				//points 2 previous class instance (or -1 if highest one)

    __int64	start;
    __int64	fstart;
    __int64 end;
    __int64 fend;

    DWORD   file_no;
    DWORD   line_cntr;

    char    *name;
    int     pass;

    DWORD   _fsize;				//holds the 2 predefined labels, to preset later
    DWORD   _size;

} CLASSLIST;


//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class ASMCLASS
{
public:
    ASMCLASS();
    DWORD _get(char *, DWORD);
    CLASSLIST *get(DWORD no = (DWORD) - 1);

    DWORD add(char *, __int8);

    DWORD close(char *, __int8);
    void close_all();
    ~ASMCLASS();

    DWORD sel;
    LIST *ClassList;

private:
};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern ASMCLASS asmclass;
#endif
