#ifndef _ERRORS_
#define _ERRORS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"


//-----------------------------------------------------------------------------
//---= enum/define =-----------------------------------------------------------
//-----------------------------------------------------------------------------
#ifdef _DEBUG
  #define MAX_ERRORS	256
#else
  #define MAX_ERRORS	256		//max number of errors+warnings
#endif

#define ERR_FATAL	0xC1000
#define ERR_NORMAL	0xC2000	//default
#define ERR_WARNING	0xC4000

#define ERR_TYPE_MASK	0xFF000
#define ERR_CODE_MASK	0x00FFF

enum //flags 2 define how error should be presented
{
	ERR_SHOW_NOTHING,	//default
	ERR_SHOW_FILE,
	ERR_SHOW_LINE,
	ERR_SHOW_POS
};

enum //return codes
{
	RETC_OK,
	RETC_UNKNOWN =RETC_OK,

	RETC_DIV_BY_ZERO,
	RETC_TOO_MANY_CALLS,

	RETC_UNKWN_CMDPARAM,

	RETC_TOO_MANY_ERR,
	RETC_TOO_MANY_FILES,
	RETC_OUTOFMEM,
	RETC_LISTALLOC,
	RETC_LISTREQUEST,

	RETC_FOPEN,
	RETC_FCREATE,
	RETC_FREAD,
	RETC_FWRITE,
	RETC_FACCESS,
	RETC_LINE2LONG,

	RETC_INCLUDE_ERR,
	RETC_INCLUDE_ABORT,
	RETC_MACRO_ERR,
	RETC_MACRO_ABORT,
	RETC_IFELSE_ERR,
	RETC_IFELSE_ABORT,

	RETC_PASS_DEPENDENT,

	RETC_NC_REGION,
	RETC_TARG_MISMATCH,
	RETC_UNKWN_INSTR,
	RETC_UNKWN_LBL_SYNTAX,
	RETC_KEY_OVERWRITE,
	RETC_LBL_OVERWRITE,
	RETC_MACRO_OVERWRITE,
	RETC_MARK_MISSING,		//mark is expected
	RETC_PARAM_EXPECTED,
	RETC_UNKWN_INSTR_SYNTAX,
	RETC_DELIMITER_EXPECTED,

	RETC_BRACKET_OPEN,		//bracket not closed
	RETC_BRACKET_CLOSE,		//bracket closed, but not opened
	RETC_OVERFLOW,			//value exceeded 64bit signed
	RETC_SYNTAX_ERR,		//syntax error (wrong char or space in param)
	RETC_TOO_MUCH_PARAMS,
	RETC_TARG_ALRD_SEL,

	RETC_NO_LBLS_ALLOWED,

	//returncodes 4 process_instruction
	RETC_REG_OVRFLW, RETC_REG_OVRFLW1,RETC_REG_OVRFLW2,RETC_REG_OVRFLW3,
	RETC_IMM_OVRFLW, RETC_IMM_OVRFLW1,RETC_IMM_OVRFLW2,RETC_IMM_OVRFLW3,
	RETC_OFF_OVRFLW, RETC_OFF_OVRFLW1,RETC_OFF_OVRFLW2,RETC_OFF_OVRFLW3,
	RETC_OFF_INVALID, RETC_OFF_INVALID1,RETC_OFF_INVALID2,RETC_OFF_INVALID3,
	RETC_TARG_OVRFLW, RETC_TARG_OVRFLW1,RETC_TARG_OVRFLW2,RETC_TARG_OVRFLW3,
	RETC_TARG_INVALID, RETC_TARG_INVALID1,RETC_TARG_INVALID2,RETC_TARG_INVALID3,
	RETC_CODE_OVRFLW, RETC_CODE_OVRFLW1,RETC_CODE_OVRFLW2,RETC_CODE_OVRFLW3,
	RETC_WRONG_PTYPE, RETC_WRONG_PTYPE1,RETC_WRONG_PTYPE2,RETC_WRONG_PTYPE3,

	RETC_ELSE_WO_IF, RETC_ENDIF_WO_IF, RETC_ENDIF_EXPECTED,
	RETC_MACRO_EXPECTED, RETC_ENDM_EXPECTED,
	RETC_TABLE_EXPECTED, RETC_ENDT_EXPECTED,
	RETC_PROC_EXPECTED, RETC_ENDP_EXPECTED,
	RETC_SEG_EXPECTED, RETC_ENDS_EXPECTED,
	RETC_VPUCODE_EXPECTED, RETC_ENDVPU_EXPECTED,

  RETC_ISET_LOCKED,   //try to change target inside of a vpucode block

	RETC_ERR_IN_MSG,		//error in a MESSAGE-directive

  RETC_LABEL_UNDEF,		//used label is undefined, yet
	RETC_EXTRA_CHAR,
	RETC_OVRWR_ASSIGN,
	RETC_OVRWR_EOF,
	_RETC_LAST
};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern DWORD error_cntr;
extern DWORD warning_cntr;
extern ofstream errorFile;

//extern BOOL err_hide;

extern void do_error(DWORD, BYTE);
extern void do_umsg(char*);
#endif
