//=============================================================================
// LIST CLASS
//=============================================================================

#include "lists.h"
#include "errors.h"


//-----------------------------------------------------------------------------
// constructor: allocate one element (1*size) and init list to zero
//-----------------------------------------------------------------------------
LIST::LIST( DWORD _size1e )
{
	dbgout("LIST(0)::LIST(" << _size1e << ") ")

	members = 0;
	size1e = ((_size1e+15)>>4)<<4;	//align 16
	h = NULL;

	dbgout("-> " << size1e << "\n");
}

//-----------------------------------------------------------------------------
// LIST::add: add one item to list and return ptr
//-----------------------------------------------------------------------------
void *LIST::add()
{
	dbgout("LIST(" << (DWORD)h << ")::add() ")

	void *h_new;

	members++;
	if(!h) h_new = malloc( members*size1e );
	else h_new = realloc(h, members*size1e);
	if(!h_new) do_error(ERR_FATAL|RETC_LISTALLOC, 0);
	h = h_new;

	h_new = (void *)( ((char *)h_new) + (members-1)*size1e );
	memset(h_new, 0, size1e);

	dbgout("-> (" << (DWORD)h << ")" << (DWORD)h_new << "\n")

	return( h_new );
}

//-----------------------------------------------------------------------------
// LIST::get: get ptr of item
//-----------------------------------------------------------------------------
void *LIST::get( DWORD item_no )
{
	//dbgout("LIST(" << (DWORD)h << ")::get(" << item_no << ")\n")

	if((!h)||(item_no>=members)) return( NULL );
	return( (void *)( ((char *)h) + item_no*size1e ) );
}
/*
//-----------------------------------------------------------------------------
// LIST::resize: cut members >= the specified number
//-----------------------------------------------------------------------------
void *LIST::resize( DWORD new_members )
{
	dbgout("LIST(" << (DWORD)h << ")::resize(" << new_members << ")\n")

	if((!h)||(new_members > members)) return(NULL);
	if(new_members < members)
	{

		void *h_new;

		members = new_members;
		if(!h) h_new = malloc( members*size1e );
		else h_new = realloc(h, members*size1e);
		if(!h_new) do_error(ERR_FATAL|RETC_LISTALLOC, 0);
		h =	h_new;

	}

	return(h);
}
*/
//-----------------------------------------------------------------------------
// LIST::kill: free and reset 2 begin
//-----------------------------------------------------------------------------
void LIST::kill()
{
	dbgout("LIST(" << (DWORD)h << ")::kill()\n")

	if(h) free(h);

	members = 0;
	h = NULL;
}

//-----------------------------------------------------------------------------
// destructor: release all mem
//-----------------------------------------------------------------------------
LIST::~LIST()
{
	dbgout("LIST(" << (DWORD)h << ")::~LIST()\n")

	if(h) free(h);
}
